> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update lifecycle rule

> Updates an existing lifecycle rule for an object storage bucket.



## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples patch /storage/buckets/{bucket_id}/lifecycle_rules/{id}
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Baselines (Preview)
    description: >-
      Preview. Available to teams with the `baselines_api` feature flag. The
      shape of these endpoints may change before general availability.
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Marketplace apps
  - name: Operating Systems
  - name: Plans
  - name: Public Networks
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Block Storage
  - name: Filesystem Storage
  - name: Object Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
  - name: Virtual machine backups
  - name: Virtual machine restores
paths:
  /storage/buckets/{bucket_id}/lifecycle_rules/{id}:
    patch:
      tags:
        - Object Storage
      summary: Update lifecycle rule
      description: Updates an existing lifecycle rule for an object storage bucket.
      operationId: patch-storage-bucket-lifecycle-rule
      parameters:
        - name: bucket_id
          in: path
          required: true
          description: The object storage bucket ID
          schema:
            type: string
        - name: id
          in: path
          required: true
          description: The lifecycle rule ID
          schema:
            type: string
      requestBody:
        required: true
        content:
          application/vnd.api+json:
            schema:
              type: object
              required:
                - data
              properties:
                data:
                  type: object
                  required:
                    - type
                    - attributes
                  properties:
                    type:
                      type: string
                      enum:
                        - lifecycle_rules
                    attributes:
                      type: object
                      required:
                        - name
                      properties:
                        name:
                          type: string
                          description: Name of the lifecycle rule
                        enabled:
                          type: boolean
                          description: Whether the rule is active
                        prefix:
                          type: string
                          nullable: true
                          description: >-
                            Object key prefix to filter which objects the rule
                            applies to
                        expiration_days:
                          type: integer
                          minimum: 1
                          description: >-
                            Number of days after object creation when the object
                            expires
                        noncurrent_days:
                          type: integer
                          minimum: 1
                          nullable: true
                          description: >-
                            Number of days after which noncurrent object
                            versions expire
                        abort_mpu_days_after_initiation:
                          type: integer
                          minimum: 1
                          nullable: true
                          description: >-
                            Number of days after initiation to abort incomplete
                            multipart uploads
            examples:
              Update:
                summary: Update lifecycle rule
                value:
                  data:
                    type: lifecycle_rules
                    attributes:
                      name: delete-old-logs
                      enabled: false
                      expiration_days: 60
      responses:
        '200':
          description: Success
          content:
            application/vnd.api+json:
              examples:
                Success:
                  value:
                    data:
                      id: lifecycle_7Rk2Wd38dXnZJ
                      type: lifecycle_rules
                      attributes:
                        name: delete-old-logs
                        enabled: false
                        prefix: logs/
                        expiration_days: 60
                        noncurrent_days: null
                        abort_mpu_days_after_initiation: null
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/lifecycle_rule_data'
        '403':
          description: Forbidden
          content:
            application/vnd.api+json:
              examples:
                FeatureNotEnabled:
                  value:
                    errors:
                      - code: STORAGE_NOT_ENABLED
                        title: Object Storage not enabled
                        detail: Object Storage is not enabled for this team
                        meta: {}
                        status: '403'
                InsufficientPermissions:
                  value:
                    errors:
                      - code: USER_AUTHORIZATION_ERROR
                        status: forbidden
                        title: User Authorization Error
                        detail: You are not authorized to perform this action.
                        meta: {}
              schema:
                $ref: '#/components/schemas/error_object'
        '404':
          description: Not Found
          content:
            application/vnd.api+json:
              examples:
                NotFound:
                  value:
                    errors:
                      - code: not_found
                        title: Error
                        detail: Specified Record Not Found
                        meta: {}
                        status: '404'
              schema:
                $ref: '#/components/schemas/error_object'
        '422':
          description: Unprocessable Entity
          content:
            application/vnd.api+json:
              examples:
                ValidationError:
                  value:
                    errors:
                      - code: VALIDATION_ERROR
                        title: Validation Error
                        detail: expiration_days must be greater than 0
                        meta: {}
                        status: '422'
              schema:
                $ref: '#/components/schemas/error_object'
        '500':
          description: Internal Server Error
          content:
            application/vnd.api+json:
              examples:
                UpdateError:
                  value:
                    errors:
                      - code: LIFECYCLE_RULE_UPDATE_ERROR
                        title: Lifecycle rule update error
                        detail: Failed to update lifecycle rule on storage provider
                        meta: {}
                        status: '500'
              schema:
                $ref: '#/components/schemas/error_object'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.ObjectStorage.PatchStorageBucketLifecycleRule(ctx, \"<id>\", \"<id>\", operations.PatchStorageBucketLifecycleRuleRequestBody{\n        Data: operations.PatchStorageBucketLifecycleRuleData{\n            Type: operations.PatchStorageBucketLifecycleRuleTypeLifecycleRules,\n            Attributes: operations.PatchStorageBucketLifecycleRuleAttributes{\n                Name: \"delete-old-logs\",\n                Enabled: latitudeshgosdk.Pointer(false),\n                ExpirationDays: latitudeshgosdk.Pointer[int64](60),\n            },\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.Object != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.objectStorage.patchStorageBucketLifecycleRule({
                bucketId: "<id>",
                id: "<id>",
                requestBody: {
                  data: {
                    type: "lifecycle_rules",
                    attributes: {
                      name: "delete-old-logs",
                      enabled: false,
                      expirationDays: 60,
                    },
                  },
                },
              });

              console.log(result);
            }

            run();
components:
  schemas:
    lifecycle_rule_data:
      type: object
      properties:
        id:
          type: string
          description: Lifecycle rule ID with lifecycle_ prefix
        type:
          type: string
          enum:
            - lifecycle_rules
        attributes:
          type: object
          properties:
            name:
              type: string
              description: Name of the lifecycle rule
            enabled:
              type: boolean
              description: Whether the rule is currently active
            prefix:
              type: string
              nullable: true
              description: >-
                Object key prefix filter. When set, the rule only applies to
                objects whose keys start with this prefix.
            expiration_days:
              type: integer
              description: >-
                Number of days after object creation when the object expires and
                is automatically deleted
            noncurrent_days:
              type: integer
              nullable: true
              description: >-
                Number of days after which noncurrent object versions expire
                (for versioned buckets)
            abort_mpu_days_after_initiation:
              type: integer
              nullable: true
              description: >-
                Number of days after initiation to abort incomplete multipart
                uploads
    error_object:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              code:
                type: string
                nullable: true
              status:
                type: string
              title:
                type: string
              detail:
                type: string
              source:
                type: object
                properties:
                  pointer:
                    type: string
                  parameter:
                    type: string
              meta:
                type: object
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````